Index: applications/editors/josm/plugins/wms-turbo-challenge2/.classpath
===================================================================
--- applications/editors/josm/plugins/wms-turbo-challenge2/.classpath	(revision 24997)
+++ applications/editors/josm/plugins/wms-turbo-challenge2/.classpath	(revision 24999)
@@ -4,5 +4,4 @@
 	<classpathentry kind="con" path="org.eclipse.jdt.launching.JRE_CONTAINER"/>
 	<classpathentry combineaccessrules="false" kind="src" path="/JOSM"/>
-	<classpathentry combineaccessrules="false" kind="src" path="/wmsplugin"/>
 	<classpathentry kind="output" path="build"/>
 </classpath>
Index: applications/editors/josm/plugins/wms-turbo-challenge2/build.xml
===================================================================
--- applications/editors/josm/plugins/wms-turbo-challenge2/build.xml	(revision 24997)
+++ applications/editors/josm/plugins/wms-turbo-challenge2/build.xml	(revision 24999)
@@ -16,5 +16,4 @@
     <property name="plugin.dist.dir"        value="../../dist"/>
     <property name="plugin.jar"             value="${plugin.dist.dir}/${ant.project.name}.jar"/>
-    <property name="wmsplugin"              location="${plugin.dist.dir}/wmsplugin.jar:${user.home}/.josm/plugins/wmsplugin.jar"/>
 
     <!--
@@ -34,5 +33,5 @@
     <target name="compile" depends="init">
         <echo message="compiling sources for  ${plugin.jar} ... "/>
-        <javac srcdir="src" classpath="${josm}:${wmsplugin}" debug="true" destdir="${plugin.build.dir}">
+        <javac srcdir="src" classpath="${josm}" debug="true" destdir="${plugin.build.dir}">
             <compilerarg value="-Xlint:deprecation"/>
             <compilerarg value="-Xlint:unchecked"/>
@@ -67,5 +66,5 @@
                 <attribute name="Plugin-Icon" value="images/wmsracer.png"/>
                 <attribute name="Plugin-Link" value="http://wiki.openstreetmap.org/wiki/JOSM/Plugins/WMS_Racer"/>
-                <attribute name="Plugin-Mainversion" value="3252"/>
+                <attribute name="Plugin-Mainversion" value="3715"/>
                 <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
             </manifest>
Index: applications/editors/josm/plugins/wms-turbo-challenge2/src/wmsturbochallenge/GameWindow.java
===================================================================
--- applications/editors/josm/plugins/wms-turbo-challenge2/src/wmsturbochallenge/GameWindow.java	(revision 24997)
+++ applications/editors/josm/plugins/wms-turbo-challenge2/src/wmsturbochallenge/GameWindow.java	(revision 24999)
@@ -6,38 +6,34 @@
 package wmsturbochallenge;
 
-import org.openstreetmap.josm.gui.layer.Layer;
-import org.openstreetmap.josm.gui.layer.GpxLayer;
-import org.openstreetmap.josm.gui.MapView;
+import java.awt.Color;
+import java.awt.Graphics;
+import java.awt.Image;
+import java.awt.Point;
+import java.awt.Toolkit;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+import java.awt.event.KeyAdapter;
+import java.awt.event.KeyEvent;
+import java.awt.image.BufferedImage;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.Collection;
+import java.util.HashMap;
+import java.util.List;
+
+import javax.swing.ImageIcon;
+import javax.swing.JFrame;
+import javax.swing.JPanel;
+import javax.swing.Timer;
+
 import org.openstreetmap.josm.Main;
-
 import org.openstreetmap.josm.data.ProjectionBounds;
 import org.openstreetmap.josm.data.coor.EastNorth;
-import org.openstreetmap.josm.data.coor.LatLon;
 import org.openstreetmap.josm.data.gpx.GpxData;
-import org.openstreetmap.josm.data.gpx.GpxTrack;
 import org.openstreetmap.josm.data.gpx.ImmutableGpxTrack;
 import org.openstreetmap.josm.data.gpx.WayPoint;
-
-import java.util.Collection;
-import java.util.ArrayList;
-import java.util.List;
-import java.util.Arrays;
-import java.util.HashMap;
-
-import java.awt.Point;
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
-import java.awt.event.KeyEvent;
-import java.awt.event.KeyAdapter;
-import java.awt.Toolkit;
-import java.awt.Graphics;
-import java.awt.Color;
-import java.awt.Image;
-import java.awt.image.BufferedImage;
-
-import javax.swing.JFrame;
-import javax.swing.JPanel;
-import javax.swing.ImageIcon;
-import javax.swing.Timer;
+import org.openstreetmap.josm.gui.layer.GpxLayer;
+import org.openstreetmap.josm.gui.layer.Layer;
+import org.openstreetmap.josm.gui.layer.WMSLayer;
 
 public class GameWindow extends JFrame implements ActionListener {
@@ -110,4 +106,5 @@
         }
 
+        @Override
         public void start() {
             super.start();
@@ -394,6 +391,6 @@
         /* If the layer is a WMS layer, check if any tiles are
          * missing */
-        if (ground instanceof wmsplugin.WMSLayer) {
-            wmsplugin.WMSLayer wms = (wmsplugin.WMSLayer) ground;
+        if (ground instanceof WMSLayer) {
+            WMSLayer wms = (WMSLayer) ground;
             downloading = wms.hasAutoDownload() && (
                     null == wms.findImage(new EastNorth(
@@ -590,4 +587,5 @@
         }
 
+        @Override
         public void paint(Graphics g) {
             int w = (int) getSize().getWidth();
@@ -639,4 +637,5 @@
 
     protected class TAdapter extends KeyAdapter {
+        @Override
         public void keyPressed(KeyEvent e) {
             int key = e.getKeyCode();
@@ -682,4 +681,5 @@
         }
 
+        @Override
         public void keyReleased(KeyEvent e) {
             int key = e.getKeyCode();